﻿using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Verse;

namespace Koyan
{
    public class Hediff_MoodSwings : HediffWithComps
    {
        public int nextMoodTick = -1;

        public override void ExposeData()
        {
            base.ExposeData();
            Scribe_Values.Look(ref nextMoodTick, "nextMoodTick", -1);
        }

        public override void Tick()
        {
            base.Tick();
            if(nextMoodTick == -1)
            {
                nextMoodTick = Rand.Range(120000, 150000);
            }
            if(nextMoodTick < Find.TickManager.TicksGame)
            {
                GiveMoodSwing();
            }
        }

        public void GiveMoodSwing()
        {
            Thought_Memory memory = new Thought_Memory
            {
                def = KoyanDefOf.ERN_KoyanMood,
                moodOffset = Rand.Range(-8, 8)
            };
            pawn.needs.mood.thoughts.memories.TryGainMemory(memory);
            nextMoodTick = Find.TickManager.TicksGame + Rand.Range(120000, 150000);
        }
    }
}
