﻿using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Verse;
using Verse.AI;

namespace Koyan
{
    public class JobDriver_TailChase : JobDriver
	{
		public override bool TryMakePreToilReservations(bool errorOnFailed)
		{
			return true;
		}

		public override IEnumerable<Toil> MakeNewToils()
		{
			yield return Toils_Goto.GotoCell(TargetIndex.A, PathEndMode.OnCell);
			Toil toil = new Toil();
			toil.AddPreTickAction(delegate
			{
				SpinMothafucka();
			});
			toil.tickAction = delegate
			{
				JoyUtility.JoyTickCheckEnd(pawn, JoyTickFullJoyAction.EndJob);
			};
			toil.defaultCompleteMode = ToilCompleteMode.Delay;
			toil.defaultDuration = job.def.joyDuration;
			toil.handlingFacing = true;
			yield return toil;
		}

		public void SpinMothafucka()
        {
            if (pawn.IsHashIntervalTick(8))
            {
				if(pawn.Rotation == Rot4.South) { pawn.Rotation = Rot4.East; }
				else if (pawn.Rotation == Rot4.East) { pawn.Rotation = Rot4.North; }
				else if (pawn.Rotation == Rot4.North) { pawn.Rotation = Rot4.West; }
                else { pawn.Rotation = Rot4.South;}
			}
			JoyUtility.JoyTickCheckEnd(pawn, JoyTickFullJoyAction.EndJob, 1f, (Building)base.TargetThingA);
		}
	}
}
