﻿using HarmonyLib;
using RimWorld;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Verse;

namespace Koyan
{
    public class KoyanMod : Mod
    {
        public static KoyanMod mod;

        public static string VersionDir => Path.Combine(ModLister.GetActiveModWithIdentifier("Erin.Koyan").RootDir.FullName, "Version.txt");
        public static string CurrentVersion { get; private set; }

        public KoyanMod(ModContentPack content) : base(content)
        {
            mod = this;

            Version version = Assembly.GetExecutingAssembly().GetName().Version;
            CurrentVersion = $"{version.Major}.{version.Minor}.{version.Build}";

            LogUtil.LogMessage($"{CurrentVersion} ::");

            if (Prefs.DevMode)
            {
                File.WriteAllText(VersionDir, CurrentVersion);
            }

            Harmony harmony = new Harmony("Neronix17.Koyan.RimWorld");
            harmony.PatchAll(Assembly.GetExecutingAssembly());
        }
    }
}
